using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Menu_Menu_Menu
{
    public partial class Form2 : Form
    {
        Form1 form;
        int slotIndx;

        public Form2(Form1 form, int MapSlotIndx, string tagPath)
        {
            InitializeComponent();
            this.form = form;
            this.slotIndx = MapSlotIndx;

            for (int x = 0; x < form.map.tags.tagsList.Length; x++)
            {
                if (form.map.tags.tagsList[x].Type == "bitm")
                    lit.Items.Add(form.map.tags.tagsList[x].Path);
            }
            lit.SelectedIndex = lit.Items.IndexOf(tagPath);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            FileStream fs = new FileStream(form.map.path, FileMode.Open, 
                FileAccess.ReadWrite, FileShare.ReadWrite);

            BinaryReader br = new BinaryReader(fs);
            BinaryWriter bw = new BinaryWriter(fs);

            form.menu.Slots[slotIndx].TagID = form.map.tags.tagsList[
                form.map.tags.IndexOf("bitm", lit.SelectedItem.ToString())
                ].Ident;

            bw.BaseStream.Position = form.menu.SlotsOffset + (slotIndx * form.menu.CurSlotSize) + 8;
            if (form.menu.MapFilter == MapFilter.SinglePlayer) bw.BaseStream.Position += 4;
            bw.Write(form.menu.Slots[slotIndx].TagID);

            form.menu.ReadMapSlotImage(br, slotIndx);
            br.Close();
            bw.Close();

            form.imageList1.Images.Clear();    
 
            for (int x = 0; x < form.menu.SlotsCount; x++)
               form.imageList1.Images.Add(form.menu.Slots[x].Image);

            form.prev.Image = form.menu.Slots[slotIndx].Image;
            this.Close();
        }

        private void lit_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (lit.SelectedItem != null)
            {
                BinaryReader br = new BinaryReader(new FileStream(form.map.path,
                  FileMode.Open, FileAccess.ReadWrite, FileShare.ReadWrite));

                int tagIndx = form.map.tags.IndexOf("bitm", lit.SelectedItem.ToString());
                br.BaseStream.Position = form.map.tags.tagsList[tagIndx].MetaOffset + 68 + 4;

                int tempr = br.ReadInt32() - form.map.index.secondaryMagic;
                br.BaseStream.Position = tempr;

                BitmapInfo bi = new BitmapInfo(br);
                br.BaseStream.Position += 4;

                int ImgOffset = br.ReadInt32();
                br.BaseStream.Position += 20;
                int ImgSize = br.ReadInt32();

                br.BaseStream.Position = ImgOffset;
                pictureBox1.Image = form.map.bitm.DecodeByteArrayAndReturnBitmap(
                    br.ReadBytes(ImgSize), bi, 0, 0);

                label5.Text = "Size: " + bi.Width + "x" + bi.Height;
                label6.Text = "Format: " + bi.bitmFormat.ToString();
                label9.Text = "MipMap Count: " + bi.MipMapCount.ToString();
                label7.Text = "Swizzled: " + bi.Swizzled.ToString();

                br.Close();
                button1.Enabled = (pictureBox1.Image != null);
            }
            else button1.Enabled = false;
        }
    }
}